// Copyright 2003-2006 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// <http://www.omnigroup.com/developer/sourcecode/sourcelicense/>.
//
// $Header: svn+ssh://source.omnigroup.com/Source/svn/Omni/tags/OmniSourceRelease_2006-09-07/OmniGroup/Frameworks/OmniInspector/OIInspectionSet.h 79095 2006-09-08 00:19:03Z kc $

#import <OmniFoundation/OFObject.h>

@class NSArray, NSMutableSet;
#if defined(MAC_OS_X_VERSION_10_4) && MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4
@class NSPredicate;
#endif

typedef BOOL (*OIInspectionSetPredicateFunction)(id anObject, void *context);

#import <CoreFoundation/CFDictionary.h> // For CFMutableDictionaryRef

@interface OIInspectionSet : OFObject
{
    CFMutableDictionaryRef objects;
    unsigned int insertionSequence;
}

- (void)addObject:(id)object;
- (void)addObjectsFromArray:(NSArray *)objects;
- (void)removeObject:(id)object;
- (void)removeObjectsInArray:(NSArray *)toRemove;

- (BOOL)containsObject:(id)object;
- (unsigned int)count;

- (NSArray *)allObjects;

#if defined(MAC_OS_X_VERSION_10_4) && MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4
- (NSArray *)copyObjectsSatisfyingPredicate:(NSPredicate *)predicate;
- (void)removeObjectsSatisfyingPredicate:(NSPredicate *)predicate;
#else
- (NSArray *)objectsOfClass:(Class)cls;
- (void)removeObjectsOfClass:(Class)cls;
#endif
- (NSArray *)copyObjectsSatisfyingPredicateFunction:(OIInspectionSetPredicateFunction)predicate context:(void *)context;

- (NSArray *)objectsSortedByInsertionOrder:(NSArray *)someObjects;

@end
